> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/android/changelogs/version-5/v5-9-4.md).

# Version 5.9.4 Changelog (May 30, 2013)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

Version: 5.9.4.18907

Release Date: May 30, 2013

### NEW

* Added PDFViewCtrl.setUrlExtraction() and PDFViewCtrl.getLinkAt(). They can be used to enable automatic URL extraction (it detects URL links and email addresses) and check if there is a link at a specific location.
* Added PDFViewCtrl.setPageBorderVisibility() to create a thin border around each page.
* Added PDFViewCtrl.rotateClockwise(), PDFViewCtrl.rotateCounterClockwise() and PDFViewCtrl.getPageRotation() to rotate all pages of the document.
* Added PDFViewCtrl.setupThumbnails() to setup thumbnail usage. With this new method it is also possible to setup a persistent cache for PDF page thumbnails.
* Added PDFViewCtrl.setVerticalAlign() and PDFViewCtrl.setHorizontalAlign() to set the alignment used for rendering pages within the view.
* Added Page.getVisibleContentBox(), that returns the smallest rectangle that includes all the visible content on the page.
* Added new DocumentLoadListener interface, which can be used to listen events for when the page is loaded and set.
* Added PDFViewCtrl.ErrorReportListener interface and PDFViewCtrl.setErrorReportListener() to listen for error reports in case an error is encountered during page rendering.
* Added "Go To Page" feature to the sample app PDFViewCtrlDemo.

### CHANGES

* PDFViewCtrl.setUseThumbView() was deprecated and replaced by PDFViewCtrl.setupThumbnails().
* Changed PDFViewCtrl.findText() to run always asynchronously.

### BUG FIXES

* Fixed an issue with x86 build that would cause a crash during library initialization.
* Fixed an issue that would cause a crash when destroying PDFViewCtrl.
* Fixed an issue that would cause PDFViewCtrl to have an incorrect layout on certain layout schemas.
* Misc bug fixes and improvements.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/android/changelogs/version-5/v5-9-4.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
